import sys

def col_mat(mat,j):
	"Return the column j of the matrix"
	return [row[j] for row in mat]


def media_mat(x):
	"Computing the average of the matrix x"
	med=[]
	for i in range(len(x)):
		med.append(sum(x[i])/len(x[i]))
	return med



def media_mat_col(x):
	"Computing the average of the matrix x (for columns)"
	med=[]
	ncol=len(x[0])
	nrow=len(x)
	for j in range(ncol):
		tmpcol=col_mat(x,j)	
		med.append(sum(tmpcol))
	return [y/nrow for y in med]


def media(x):
	"Computing the average of the list x"
	tmp=sum(x)/len(x)
	return tmp
		
		
if __name__ == "__main__":

	if len (sys.argv) != 3:      #nome del porgramma + 2 argomenti
		print "Uso: %s <nomwe_file> <num_colonne>" % sys.argv[0]
		sys.exit (-1)
	FILENAME=sys.argv[1]
	num_col=int(sys.argv[2])
	try: 
		fp=open (FILENAME,'r')
	except IOError:
		print "File %s not found" % FILENAME
		exit (-1)	
	linee=fp.readlines()
	fp.close()
	mat_stringhe=[i.strip().split() for i in linee]
	mat_float= [[float(col) for col in riga] for riga in mat_stringhe]
	#verifico le colonne
	if len(mat_float[0]) !=num_col:
		print "Errore: mi aspetto %d colonne, ne ho lette %d." % (num_col, len(mat_float[0]))
		sys.exit (-1)

	print "Letta Matrice [%d][%d]  :" % (len(mat_float), len(mat_float[0]))
	print
	for i in range(len(mat_float)):
		for j in range(len(mat_float[i])):
			print mat_float[i][j],"\t",
		print
	


	print "Average by row"
	print media_mat(mat_float)


	print "AVerage by col"
	print media_mat_col(mat_float)